plugins {
    id("jfmod") version "1.5-SNAPSHOT"
}

allprojects { group = "io.gitlab.jfronny" }
base.archivesName = "yescheat"

jfMod {
    minecraftVersion = "1.20.1"
    yarn("build.9")
    loaderVersion = "0.14.21"
    libJfVersion = "3.9.2"

    modrinth {
        projectId = "yescheat"
        requiredDependencies.addAll("libjf", "fabric-api")
    }
}

dependencies {
    modImplementation("io.gitlab.jfronny.libjf:libjf-config-core-v1:${jfMod.libJfVersion.get()}")
    modImplementation("net.fabricmc.fabric-api:fabric-api:0.85.0+${jfMod.minecraftVersion.get()}")

    // Dev env
    modLocalRuntime("io.gitlab.jfronny.libjf:libjf-config-ui-tiny-v1:${jfMod.libJfVersion.get()}")
    modLocalRuntime("io.gitlab.jfronny.libjf:libjf-devutil:${jfMod.libJfVersion.get()}")
    modLocalRuntime("com.terraformersmc:modmenu:7.1.0")
}